#!/usr/bin/python

import json
from struct import unpack_from
import sys

from ocr import OCRNeuralNetwork

fff = open(sys.argv[1], "rb")

z = {}

theta1 = []
theta2 = []
b1 = []
b2 = []

known_nums = {}

for char in xrange(32):
    print "Loading %d..." % char
    theta1 = []
    theta2 = []
    b1 = []
    b2 = []
    discard = fff.read(3200)
    numind = (char+1)%10
    if numind not in known_nums:
        t=[]
        print "Getting Number %d!" % numind
        while len(discard)>0:
            x, = unpack_from("<d", discard)
            if x < 0.10:
                t.append(0)
            else:
                t.append(1)
            discard = discard[8:]
        known_nums[numind] = t

    for i in xrange(160):
        osef = fff.read(8*2)
        bias, = unpack_from("<d", fff.read(8))
        b1.append(bias)
        big = fff.read(3200)
        t = []
        while len(big)>0:
            x, = unpack_from("<d", big)
            t.append(x)
            big = big[8:]
        theta1.append(t)
        osef = fff.read(8*2)

    for i in xrange(4):
        osef = fff.read(8*2)
        bias, = unpack_from("<d", fff.read(8))
        b2.append(bias)
        big = fff.read(1280)
        t = []
        while len(big)>0:
            x, = unpack_from("<d", big)
            t.append(x)
            big = big[8:]
        theta2.append(t)
        osef = fff.read(8*2)

    open("xx%d.json" % char,"wb").write(json.dumps({"theta1": theta1, "theta2": theta2, "b1": b1, "b2": b2}))

HIDDEN_NODE_COUNT = 160
final = ""
for char in xrange(32):
    nn = OCRNeuralNetwork(HIDDEN_NODE_COUNT, [], [], list(range(5000)));
    nn._load("xx%d.json" % char)
    print "====== %d ======" % char
    for num in known_nums:
        #print num, nn.predict(known_nums[num])
        res = nn.predict(known_nums[num])
        ok = True
        for k in res:
            if k>0.15:
                ok = False
        if ok:
            print "FOUND! %d" % num
            final += "%d" % num
            break

print final
