#!/usr/bin/python

import sys
from struct import unpack_from

class RC4:
    def __init__(self, key = None):
        self.state = list(range(256))
        self.x = self.y = 0 
 
        if key is not None:
            self.init(key)
 
    
    def init(self, key):
        for i in range(256):
            self.x = (ord(key[i % len(key)]) + self.state[i] + self.x) & 0xFF
            self.state[i], self.state[self.x] = self.state[self.x], self.state[i]
        self.x = 0
 
    
    def crypt(self, input):
        output = [None]*len(input)
        for i in range(len(input)):
            self.x = (self.x + 1) & 0xFF
            self.y = (self.state[self.x] + self.y) & 0xFF
            self.state[self.x], self.state[self.y] = self.state[self.y], self.state[self.x]
            output[i] = chr((ord(input[i]) ^ self.state[(self.state[self.x] + self.state[self.y]) & 0xFF]))
        return ''.join(output)

fff = open(sys.argv[1], "rb")

fn = 0

while True:
    len1, = unpack_from("<L", fff.read(4))
    data1 = fff.read(len1+0x20)

    key1 = data1[:16]
    md51 = data1[16:32]
    data_left1 = data1[32:]

    a = RC4(key1)
    open("outfile.%d"%fn,"wb").write(a.crypt(data_left1))
    fn += 1
